#extension GL_OES_EGL_image_external : require
precision mediump int;
precision mediump float;

uniform samplerExternalOES sTexture;
varying vec2 vTextureCoord;
uniform float uOpacity; 

float _hable_3_0(float x) {  
    return ((x * (0.150000*x + 0.050000) + 0.004000) / (x * (0.150000*x + 0.500000) + 0.060000)) - 0.066667;
}

vec4 _main_4_0(vec4 color) { 
    // pl_shader_color_map
    vec3 _dst_luma_1_0 = vec3(0.212637, 0.715183, 0.072180);
    mat3 _cms_matrix_2_0 = mat3(1.660497, -0.124547, -0.018154, -0.587657, 1.132895, -0.100597, -0.072840, -0.008348, 1.118751);
    // pl_shader_linearize
    color.rgb = max(color.rgb, 0.0);
    color.rgb = pow(color.rgb, vec3(1.0 / 78.843750));
    color.rgb = max(color.rgb - vec3(0.835938), 0.0) / (vec3(18.851562) - vec3(18.687500) * color.rgb);
    color.rgb = pow(color.rgb, vec3(1.0 / 0.159302));
    color.rgb *= vec3(100.000000);
    color.rgb = _cms_matrix_2_0 * color.rgb;
    // pl_shader_tone_map
    float sig = max(max(color.r, color.g), color.b);
    float sig_peak = 100.000000;
    float sig_avg = 0.250000;
    float luma = dot(_dst_luma_1_0, color.rgb);
    float coeff = max(sig - 0.18, 1e-6) / max(sig, 1e-6);
    coeff = pow(coeff, 20.000000);
    color.rgb = mix(color.rgb, vec3(luma), coeff);
    sig = mix(sig, luma, coeff);
    float sig_orig = sig;
    float slope = min(1.0, 0.250000 / sig_avg);
    sig *= slope;
    sig_peak *= slope;
    sig = _hable_3_0(sig) / _hable_3_0(sig_peak);
    sig = min(sig, 1.0);
    color.rgb *= sig / sig_orig;
    // pl_shader_delinearize
    color.rgb = max(color.rgb, 0.0);
    color.rgb = pow(color.rgb, vec3(1.0 / 2.2));
    return color;
}

void main()  
{
    vec4 Coefficients[4];
    vec4 sColor = texture2D(sTexture, vTextureCoord);
    Coefficients[0] = vec4(1.164384, 1.164384, 1.164384, 1.164384);
    Coefficients[1] = vec4(0.000000, -0.187326, 2.141772, 0.000000);
    Coefficients[2] = vec4(1.678674, -0.650424, 0.000000, 1.678674);
    Coefficients[3] = vec4(-0.915688, 0.347459, -1.148145, -0.915688);
    sColor = vec4(sColor.rgb, 1.0);
    vec4 color0 = vec4(sColor.r, sColor.r, sColor.r, 1.0);
    vec4 color1 = vec4(sColor.g, sColor.g, sColor.g, 1.0);
    vec4 color2 = vec4(sColor.b, sColor.b, sColor.b, 1.0);
    vec4 result = (color0 * Coefficients[0]) + Coefficients[3];
    result = (color1 * Coefficients[1]) + result;
    result = (color2 * Coefficients[2]) + result;
    result = _main_4_0(result);
    gl_FragColor = result;
}